Package org.eclipse.draw2d

# Class PopUpHelper

java.lang.Object
org.eclipse.draw2d.PopUpHelper

Direct Known Subclasses:
  `ToolTipHelper`

public abstract class PopUpHelper extends Object
Provides abstract support for classes that manage popups. Popups in Draw2d consist of a LightweightSystem object with an SWT shell as its Control. Desired popup behavior is attained by adding appropriate listeners to this shell.

## Field Summary

Fields
Modifier and Type
Field
Description
`protected Control`
`control`
The Control this PopUpHelper's tooltip will belong to.
`protected final int`
`shellStyle`
These style bits should be used when creating the Shell.

## Constructor Summary

Constructors
Modifier
Constructor
Description
`protected`
`PopUpHelper(Control c)`
Constructs a PopUpHelper to assist with popups on Control c.
`protected`
`PopUpHelper(Control c, int shellStyle)`
Constructs a PopUpHelper to display the given shell style popup.

## Method Summary

Modifier and Type
Method
Description
`protected LightweightSystem`
`createLightweightSystem()`
Creates and returns the LightweightSystem object used by PopUpHelper to draw upon.
`protected Shell`
`createShell()`
Creates a new Shell object with the style specified for this helper.
`void`
`dispose()`
Dispose of this PopUpHelper object.
`protected LightweightSystem`
`getLightweightSystem()`
Returns this PopUpHelper's LightweightSystem.
`protected Shell`
`getShell()`
Returns this PopUpHelper's shell.
`protected Dimension`
`getShellTrimSize()`
Returns the size needed to display the shell's trim.
`protected void`
`hide()`
Hides this PopUpHelper's Shell.
`protected abstract void`
`hookShellListeners()`
Desired popup helper behavior is achieved by writing listeners that manipulate the behavior of the PopUpHelper's Shell.
`boolean`
`isShowing()`
Returns `true` if this PopUpHelper's Shell is visible, `false` otherwise.
`void`
`setBackgroundColor(Color c)`
Sets the background color of this PopUpHelper's Shell.
`void`
`setForegroundColor(Color c)`
Sets the foreground color of this PopUpHelper's Shell.
`protected void`
`setShellBounds(int x, int y, int width, int height)`
Sets the bounds on this PopUpHelper's Shell.
`protected void`
`show()`
Displays this PopUpHelper's Shell.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Field Details

### control

protected Control control
The Control this PopUpHelper's tooltip will belong to.

### shellStyle

protected final int shellStyle
These style bits should be used when creating the Shell.

See Also:
  - `createShell()`

## Constructor Details

### PopUpHelper

protected PopUpHelper(Control c)
Constructs a PopUpHelper to assist with popups on Control c.

Parameters:
  `c` - the Control
Since:
  2.0

### PopUpHelper

protected PopUpHelper(Control c, int shellStyle)
Constructs a PopUpHelper to display the given shell style popup.

Parameters:
  `c` - the control on which the popup is active.
  `shellStyle` - the SWT style bits for the shell
Since:
  3.1

## Method Details

### createLightweightSystem

protected LightweightSystem createLightweightSystem()
Creates and returns the LightweightSystem object used by PopUpHelper to draw upon.

Returns:
  the newly created LightweightSystem
Since:
  2.0

### createShell

protected Shell createShell()
Creates a new Shell object with the style specified for this helper.

Returns:
  the newly created Shell
Since:
  2.0

### dispose

public void dispose()
Dispose of this PopUpHelper object.

Since:
  2.0

### getShell

protected Shell getShell()
Returns this PopUpHelper's shell. If no shell exists for this PopUpHelper, a new shell is created and hookShellListeners() is called.

Returns:
  the Shell
Since:
  2.0

### getShellTrimSize

protected Dimension getShellTrimSize()
Returns the size needed to display the shell's trim. This method should not be called until the shell has been created.

Returns:
  the size of the shells trim.
Since:
  3.1

### getLightweightSystem

protected LightweightSystem getLightweightSystem()
Returns this PopUpHelper's LightweightSystem. If no LightweightSystem exists for this PopUpHelper, a new LightweightSystem is created with this PopUpHelper's Shell as its Control.

Returns:
  the LightweightSystem
Since:
  2.0

### hide

protected void hide()
Hides this PopUpHelper's Shell.

Since:
  2.0

### hookShellListeners

protected abstract void hookShellListeners()
Desired popup helper behavior is achieved by writing listeners that manipulate the behavior of the PopUpHelper's Shell. Override this method and add these listeners here.

Since:
  2.0

### isShowing

public boolean isShowing()
Returns `true` if this PopUpHelper's Shell is visible, `false` otherwise.

Returns:
  `true` if this PopUpHelper's Shell is visible
Since:
  2.0

### setBackgroundColor

public void setBackgroundColor(Color c)
Sets the background color of this PopUpHelper's Shell.

Parameters:
  `c` - the new background color
Since:
  2.0

### setForegroundColor

public void setForegroundColor(Color c)
Sets the foreground color of this PopUpHelper's Shell.

Parameters:
  `c` - the new foreground color
Since:
  2.0

### setShellBounds

protected void setShellBounds(int x, int y, int width, int height)
Sets the bounds on this PopUpHelper's Shell.

Parameters:
  `x` - the x coordinate
  `y` - the y coordinate
  `width` - the width
  `height` - the height
Since:
  2.0

### show

protected void show()
Displays this PopUpHelper's Shell.

Since:
  2.0